<?php

/**
 * Copyright Souke (2018)
 *
 * contact@souke.fr
 *
 * Ce logiciel est un programme informatique servant à aider les producteurs
 * à distribuer leur production en circuits courts.
 *
 * Ce logiciel est régi par la licence CeCILL soumise au droit français et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilité au code source et des droits de copie,
 * de modification et de redistribution accordés par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 * seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concédants successifs.
 *
 * A cet égard  l'attention de l'utilisateur est attirée sur les risques
 * associés au chargement,  à l'utilisation,  à la modification et/ou au
 * développement et à la reproduction du logiciel par l'utilisateur étant
 * donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 * manipuler et qui le réserve donc à des développeurs et des professionnels
 * avertis possédant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 * logiciel à leurs besoins dans des conditions permettant d'assurer la
 * sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 * à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
 *
 * Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 * pris connaissance de la licence CeCILL, et que vous en avez accepté les
 * termes.
 */

namespace backend\controllers;

use domain\PointSale\SharedPointSale\SharedPointSale;
use domain\Feature\Feature\Feature;
use yii\filters\AccessControl;
use yii\web\NotFoundHttpException;

/**
 * UserController implements the CRUD actions for User model.
 */
class SharedPointSaleController extends BackendController
{
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'rules' => [
                    [
                        'allow' => true,
                        'roles' => ['@'],
                        'matchCallback' => function ($rule, $action) {
                            $authorizationChecker = $this->getUserModule()->getAuthorizationChecker();
                            $featureChecker = $this->getFeatureModule()->getChecker();

                            return $authorizationChecker->isGrantedAsProducer($this->getUserCurrent())
                                && $featureChecker->isEnabled(Feature::ALIAS_SHARED_POINT_SALE);
                        }
                    ]
                ],
            ],
        ];
    }

    public function actionIndex()
    {
        $sharedPointSaleRepository = $this->getSharedPointSaleModule()->getRepository();

        return $this->render('index', [
            'sharedPointsSaleRequestOfMe' => $sharedPointSaleRepository->findSharedPointsSaleRequestsOfMe(),
            'sharedPointsSaleRequestOthers' => $sharedPointSaleRepository->findSharedPointsSaleRequestsOthers(),
            'pointsSaleArray' => $this->getPointSaleModule()->getRepository()->findPointSales()
        ]);
    }

    public function actionCreate()
    {
        $sharedPointSaleModule = $this->getSharedPointSaleModule();
        $sharedPointSaleModel = $sharedPointSaleModule->getBuilder()->instanciateSharedPointSale(null, null, $this->getUserCurrent());
        $sharedPointSaleModel->scenario = SharedPointSale::SCENARIO_CREATE;
        if($sharedPointSaleModel->load(\Yii::$app->request->post()) && $sharedPointSaleModel->validate()) {
            $sharedPointSaleModule->getManager()->createSharedPointSale(
                $sharedPointSaleModel->getPointSale(),
                $sharedPointSaleModel->getProducerWithSharing(),
                $this->getUserCurrent()
            );
            $this->setFlash('success', "La demande de partage a bien été créée");
            return $this->redirect(['index']);
        }

        return $this->render('create', [
            'sharedPointSaleModel' => $sharedPointSaleModel
        ]);
    }

    public function actionConfirm(int $id)
    {
        $sharedPointSale = $this->findSharedPointSale($id);
        $sharedPointSale->scenario = SharedPointSale::SCENARIO_CONFIRM;
        $sharedPointSale->producerCurrent = $this->getProducerCurrent();

        if($sharedPointSale->load(\Yii::$app->request->post()) && $sharedPointSale->validate()) {
            $pointSaleWithSharing = $sharedPointSale->getPointSaleWithSharing();
            if($this->getSharedPointSaleModule()->getManager()->confirmSharedPointSale($sharedPointSale, $pointSaleWithSharing, $this->getUserCurrent())) {
                $this->addFlash('success', "Le partage de point de vente a bien été confirmé");
            }
            else {
                $this->addFlash('error', "Une erreur est survenue lors de la confirmation du partage");
            }
        }
        else {
            foreach($sharedPointSale->getErrors() as $errorArray) {
                foreach($errorArray as $errorMessage) {
                    $this->addFlash('error', $errorMessage);
                }
            }
        }

        return $this->redirect(['index']);
    }

    public function actionDecline(int $id)
    {
        $sharedPointSale = $this->findSharedPointSale($id);

        if(!in_array($this->getProducerCurrent()->id, [$sharedPointSale->getProducerWithSharing()->id, $sharedPointSale->getPointSale()->id_producer])) {
            $this->addFlash('error', "Vous ne pouvez pas refuser cette demande de partage.");
        }
        else {
            if($this->getSharedPointSaleModule()->getManager()->declineSharedPointSale($sharedPointSale, $this->getUserCurrent())) {
                $this->addFlash('success', "La demande de partage de point de vente a bien été annulée.");
            }
            else {
                $this->addFlash('error', "Une erreur est survenue lors de l'annulation de la demande de partage.");
            }
        }

        return $this->redirect(['index']);
    }

    public function findSharedPointSale(int $id)
    {
        $sharedPointSale = $this->getSharedPointSaleModule()->getRepository()->findOneSharedPointSaleById($id);

        if(!$sharedPointSale) {
            throw new NotFoundHttpException("La demande de point de vente partagé n'a pas été trouvée.");
        }

        return $sharedPointSale;
    }
}
